<?php
class logger {
    function logger() {
        if (is_single()) {
            global $wpdb;
            global $post;
            $section = get_post_meta($post->ID, 'e_section', true);
            $page = get_post_meta($post->ID, 'e_section_page', true);
            $date = get_post_meta($post->ID, 'e_section_date', true);

            if (($section == '') || ($page == '')) return;

            $location = geoip_record_by_name($_SERVER['REMOTE_ADDR']);

            $table_name = $wpdb->prefix . "e_section";

           /*$rows_affected = $wpdb->insert($table_name,
                array(
                    'section' => $section,
                    'page' => $page,
                    'city' => $location['city'],
                    'postal_code' => $location['postal_code'])
            ); */

           // log uniques for the day ..
           $site_name = get_option('blogname');
           $cookie_prefix = strtolower(str_replace(' ', '_', $site_name));

           $cookie = $cookie_prefix . "_e_section_tracker";
           $edition_cookie = $cookie_prefix . "_e_section_edition_tracker";

           $cookie_section = strtoupper($section . $page);
           $expires = mktime(0, 0, 0, date("m"), date("d")+1, date("Y"));
           $option_name = "e_section_tracker_" . date("mdY");
           $edition_option_name = "e_section_edition_tracker_" . date("mdY");

           if ($this->is_bot()) { return; }
           $edition_date = getESectionDate();

           // print "<br/>DON: " . $date . " == " . $edition_date[0] . "<br/>\n";
           if ($date == $edition_date[0]) {
               $this->log_hit($edition_cookie, $cookie_section, $expires, $path, $edition_option_name);
           }

           $this->log_hit($cookie, $cookie_section, $expires, $path, $option_name);

        }
    }

    function log_hit($cookie='', $section='', $expires='', $path='/', $option_name) {
        if (!$cookie) { return; }

        if (!isset($_COOKIE[$cookie])) {
            $sections = array($section);
            setcookie($cookie, base64_encode(serialize($sections)), $expires, $path);

            $tracker = get_option($option_name);
            if ($tracker) {
                if (!is_array($tracker)) { $tracker = unserialize($tracker); }

                if (isset($tracker[$section])) {
                    $tracker[$section] += 1;
                } else {
                    $tracker[$section] = 1;
                }
                $tracker['total'] += 1;
                update_option($option_name, serialize($tracker));
            } else {
                $tracker = array($section => 1, 'total' => 1);
                update_option($option_name, serialize($tracker));
            }
       } else {
            $sections = unserialize(base64_decode($_COOKIE[$cookie]));
            if (!in_array($section, $sections)) {
                array_push($sections, $section);
                setcookie($cookie, base64_encode(serialize($sections)), $expires, $path);

                $tracker = get_option($option_name);

                if ($tracker) {
                    if (!is_array($tracker)) { $tracker = unserialize($tracker); }

                    if (isset($tracker[$section])) {
                        $tracker[$section] += 1;
                    } else {
                        $tracker[$section] = 1;
                    }
                    update_option($option_name, serialize($tracker));
                }
            }
       }
    }

    function get_sections() {
        global $wpdb;
        $table_name = $wpdb->prefix . "e_section";
        $interval = $_GET['interval'];


        $sql = "SELECT section, count(id) as c FROM " . $table_name;
        if ($interval) {
            $sql .= " WHERE ts >= DATE_SUB(NOW(), INTERVAL ". $interval . " HOUR) ";
        }
        $sql .= " GROUP BY section";

        $rows = $wpdb->get_results($sql);
        return $rows;
    }

    function get_pages($section='a') {
        global $wpdb;
        $table_name = $wpdb->prefix . "e_section";
        $interval = $_GET['interval'];

        $sql = "SELECT page, count(id) as c FROM " . $table_name;
        $sql .= " WHERE section='" . $section . "' ";
        if ($interval) {
            $sql .= " AND ts >= DATE_SUB(NOW(), INTERVAL " . $interval . " HOUR) ";
        }
        $sql .= " GROUP BY page";

        $rows = $wpdb->get_results($sql);
        return $rows;
    }


    function view() {
        ?>
        	<div class="wrap" id="e-section-wrap">
        	    <div id="e-section-title">
        	        <h2>E-Section - Logger</h2>
        	    </div>
        	</div>
        	<div class="wrap">
        	<a href="?page=e-section-logger">All</a> -
        	<a href="?page=e-section-logger&interval=72">Last 72 hours</a> -
        	<a href="?page=e-section-logger&interval=24">Last 24 hours</a>
        	</div>
        <?php
        $sections = $this->get_sections();

        print '<div id="e_section_log_results">';
        foreach ($sections as $section) {
            print '<div class="section">';
            print "Section " . strtoupper($section->section) . ": " . $section->c . "<br/>";
            $pages = $this->get_pages($section->section);
            foreach ($pages as $page) {
                print '<span class="page">Page ' . strtoupper($section->section) . $page->page . ': ' . $page->c . '</span>';
            }
            print "</div>";
        }
        print "</div>";
    }

    function is_bot(){
        if ( stripos( $_SERVER['REMOTE_ADDR'], '192.168.1') !== false ) return false;

        $bots = array(
            'Googlebot', 'Baiduspider', 'ia_archiver',
            'R6_FeedFetcher', 'NetcraftSurveyAgent', 'Sogou web spider',
            'bingbot', 'Yahoo! Slurp', 'facebookexternalhit', 'PrintfulBot',
            'msnbot', 'Twitterbot', 'UnwindFetchor',
            'urlresolver', 'Butterfly', 'TweetmemeBot', 'python', 'AsyncHttpClient',
            'FAST Enterprise Crawler', 'FeedFetcher', 'Feedly', 'GermCrawler',
            'magpie', 'mediawords', 'NextGenSearchBot', 'spider', 'Showyoubot',
            'QuerySeekerSpider', 'Pinterest', 'Yeti', 'sandisk', 'DoCoMo',
            'Wordpress', 'bot', 'crawl', 'infopath', 'App3leWebKit', 'Apache',
            'PeoplePal' );


        foreach($bots as $b){

            if( stripos( $_SERVER['HTTP_USER_AGENT'], $b ) !== false ) return true;

        }

	$ips = array(
	    '113.119.52.240' );

	foreach($ips as $i){

	    if( stripos( $_SERVER['REMOTE_ADDR'], $i) !== false ) return true;

	}

	$record = geoip_record_by_name($_SERVER['REMOTE_ADDR']);
	if (!$record) { return true; }
	if ($record['country_code'] != 'US') { return true; }

        return false;
    }
}



?>
